=== added file 'COPYING.Boost'
--- COPYING.Boost	1970-01-01 00:00:00 +0000
+++ COPYING.Boost	2010-10-02 05:07:25 +0000
@@ -0,0 +1,23 @@
+Boost Software License - Version 1.0 - August 17th, 2003
+
+Permission is hereby granted, free of charge, to any person or organization
+obtaining a copy of the software and accompanying documentation covered by
+this license (the "Software") to use, reproduce, display, distribute,
+execute, and transmit the Software, and to prepare derivative works of the
+Software, and to permit third-parties to whom the Software is furnished to
+do so, all subject to the following:
+
+The copyright notices in the Software and this entire statement, including
+the above license grant, this restriction and the following disclaimer,
+must be included in all copies of the Software, in whole or in part, and
+all derivative works of the Software, unless such copies or derivative
+works are solely in the form of machine-executable object code generated by
+a source language processor.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
+SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
+FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
+ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+DEALINGS IN THE SOFTWARE.

=== modified file 'Makefile.am'
--- Makefile.am	2010-09-30 06:19:01 +0000
+++ Makefile.am	2010-10-02 05:07:25 +0000
@@ -43,6 +43,7 @@
 BUILT_MAINT_SRC=
 EXTRA_DIST= \
 	    .quickly \
+	    COPYING.Boost \
 	    COPYING.BSD \
 	    DRIZZLE.FAQ \
 	    EXCEPTIONS-CLIENT \

=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2010-09-28 21:15:33 +0000
+++ client/drizzle.cc	2010-10-02 05:07:25 +0000
@@ -158,9 +158,11 @@
 #define vidattr(A) {}      // Can't get this to work
 #endif
 #include <boost/program_options.hpp>
+#include "drizzled/program_options/config_file.h"
 
 using namespace std;
 namespace po=boost::program_options;
+namespace dpo=drizzled::program_options;
 
 /* Don't try to make a nice table if the data is too big */
 const uint32_t MAX_COLUMN_LENGTH= 1024;
@@ -1420,16 +1422,16 @@
     user_config_dir_client.append("/drizzle/client.cnf");
 
     ifstream user_drizzle_ifs(user_config_dir_drizzle.c_str());
-    po::store(parse_config_file(user_drizzle_ifs, drizzle_options), vm);
+    po::store(dpo::parse_config_file(user_drizzle_ifs, drizzle_options), vm);
 
     ifstream user_client_ifs(user_config_dir_client.c_str());
-    po::store(parse_config_file(user_client_ifs, client_options), vm);
+    po::store(dpo::parse_config_file(user_client_ifs, client_options), vm);
 
     ifstream system_drizzle_ifs(system_config_dir_drizzle.c_str());
-    store(parse_config_file(system_drizzle_ifs, drizzle_options), vm);
+    store(dpo::parse_config_file(system_drizzle_ifs, drizzle_options), vm);
  
     ifstream system_client_ifs(system_config_dir_client.c_str());
-    po::store(parse_config_file(system_client_ifs, client_options), vm);
+    po::store(dpo::parse_config_file(system_client_ifs, client_options), vm);
   }
 
   po::notify(vm);

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-10-04 22:44:31 +0000
+++ drizzled/drizzled.cc	2010-10-02 05:07:25 +0000
@@ -31,6 +31,7 @@
 #include <stdexcept>
 
 #include <boost/program_options.hpp>
+#include "drizzled/program_options/config_file.h"
 #include <boost/thread/recursive_mutex.hpp>
 #include <boost/thread/mutex.hpp>
 #include <boost/thread/condition_variable.hpp>
@@ -139,6 +140,7 @@
 using namespace std;
 namespace fs=boost::filesystem;
 namespace po=boost::program_options;
+namespace dpo=drizzled::program_options;
 
 
 namespace drizzled
@@ -1135,7 +1137,7 @@
     ifstream input_defaults_file(file_location.c_str());
     
     po::parsed_options file_parsed=
-      po::parse_config_file(input_defaults_file, full_options, true);
+      dpo::parse_config_file(input_defaults_file, full_options, true);
     vector<string> file_unknown= 
       po::collect_unrecognized(file_parsed.options, po::include_positional);
 

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-10-05 08:06:38 +0000
+++ drizzled/include.am	2010-10-02 05:07:25 +0000
@@ -322,6 +322,7 @@
 			      drizzled/plugin/xa_resource_manager.h \
 			      drizzled/plugin/xa_storage_engine.h \
 			      drizzled/probes.h \
+			      drizzled/program_options/config_file.h \
 			      drizzled/pthread_globals.h \
 			      drizzled/qsort_cmp.h \
 			      drizzled/query_id.h \

=== added directory 'drizzled/program_options'
=== added file 'drizzled/program_options/config_file.h'
--- drizzled/program_options/config_file.h	1970-01-01 00:00:00 +0000
+++ drizzled/program_options/config_file.h	2010-10-02 05:07:25 +0000
@@ -0,0 +1,339 @@
+/*
+ * Copyright (c) 2002-2004 Vladimir Prus.
+ *
+ * Distributed under the Boost Software License, Version 1.0.
+ * (See accompanying file LICENSE_1_0.txt or copy at
+ * http://www.boost.org/LICENSE_1_0.txt)
+ */
+
+#ifndef DRIZZLED_PROGRAM_OPTIONS_CONFIG_FILE_H
+#define DRIZZLED_PROGRAM_OPTIONS_CONFIG_FILE_H
+
+#include <boost/program_options.hpp>
+#include <boost/program_options/eof_iterator.hpp>
+#include <boost/static_assert.hpp>
+#include <boost/type_traits/is_same.hpp>
+#include <boost/shared_ptr.hpp>
+
+#include <boost/noncopyable.hpp>
+
+#include <iosfwd>
+#include <vector>
+#include <utility>
+#include <set>
+
+namespace drizzled
+{
+namespace program_options
+{
+
+
+namespace detail
+{
+
+namespace {
+  std::string trim_ws(const std::string& s)
+  {
+    std::string::size_type n, n2;
+    n = s.find_first_not_of(" \t\r\n");
+    if (n == std::string::npos)
+      return std::string();
+    else {
+      n2 = s.find_last_not_of(" \t\r\n");
+      return s.substr(n, n2-n+1);
+    }
+  }
+}
+
+/** Standalone parser for config files in ini-line format.
+  The parser is a model of single-pass lvalue iterator, and
+  default constructor creates past-the-end-iterator. The typical usage is:
+  config_file_iterator i(is, ... set of options ...), e;
+  for(; i !=e; ++i) {
+ *i;
+ }
+
+ Syntax conventions:
+
+ - config file can not contain positional options
+ - '#' is comment character: it is ignored together with
+ the rest of the line.
+ - variable assignments are in the form
+ name '=' value.
+ spaces around '=' are trimmed.
+ - Section names are given in brackets. 
+
+ The actual option name is constructed by combining current section
+ name and specified option name, with dot between. If section_name 
+ already contains dot at the end, new dot is not inserted. For example:
+ @verbatim
+ [gui.accessibility]
+ visual_bell=yes
+ @endverbatim
+ will result in option "gui.accessibility.visual_bell" with value
+ "yes" been returned.
+
+ */    
+class common_config_file_iterator :
+  public boost::eof_iterator<common_config_file_iterator,
+                             boost::program_options::option>
+{
+public:
+  common_config_file_iterator()
+  {
+    found_eof();
+  }
+
+  common_config_file_iterator(const std::set<std::string>& in_allowed_options,
+                              bool allow_unregistered) :
+    allowed_options(in_allowed_options),
+    m_allow_unregistered(allow_unregistered)
+  {
+    for(std::set<std::string>::const_iterator i = allowed_options.begin();
+        i != allowed_options.end(); 
+        ++i)
+    {
+      add_option(i->c_str());
+    }
+  }
+
+  virtual ~common_config_file_iterator() {}
+
+public: // Method required by eof_iterator
+
+  void get()
+  {
+    std::string s;
+    std::string::size_type n;
+    bool found = false;
+
+    while(this->getline(s)) {
+
+      // strip '#' comments and whitespace
+      if ((n = s.find('#')) != std::string::npos)
+        s = s.substr(0, n);
+      s = trim_ws(s);
+
+      if (!s.empty()) {
+        // Handle section name
+        if (*s.begin() == '[' && *s.rbegin() == ']') {
+          m_prefix = s.substr(1, s.size()-2);
+          if (*m_prefix.rbegin() != '.')
+            m_prefix += '.';
+        }
+        else if ((n = s.find('=')) != std::string::npos) {
+
+          std::string name = m_prefix + trim_ws(s.substr(0, n));
+          std::string option_value = trim_ws(s.substr(n+1));
+
+          bool registered = allowed_option(name);
+          if (!registered && !m_allow_unregistered)
+            boost::throw_exception(boost::program_options::unknown_option(name));
+
+          found = true;
+          this->value().string_key = name;
+          this->value().value.clear();
+          this->value().value.push_back(option_value);
+          this->value().unregistered = !registered;
+          this->value().original_tokens.clear();
+          this->value().original_tokens.push_back(name);
+          this->value().original_tokens.push_back(option_value);
+          break;
+
+        } else {
+          boost::throw_exception(boost::program_options::invalid_syntax(s, "Unrecognized line"));
+        }
+      }
+    }
+    if (!found)
+      found_eof();
+  }
+
+protected: // Stubs for derived classes
+
+  // Obtains next line from the config file
+  // Note: really, this design is a bit ugly
+  // The most clean thing would be to pass 'line_iterator' to
+  // constructor of this class, but to avoid templating this class
+  // we'd need polymorphic iterator, which does not exist yet.
+  virtual bool getline(std::string&) { return false; }
+
+private:
+  /** Adds another allowed option. If the 'name' ends with
+    '*', then all options with the same prefix are
+    allowed. For example, if 'name' is 'foo*', then 'foo1' and
+    'foo_bar' are allowed. */
+  void add_option(const char* name)
+  {
+    std::string s(name);
+    assert(!s.empty());
+    if (*s.rbegin() == '*') {
+      s.resize(s.size()-1);
+      bool bad_prefixes(false);
+      // If 's' is a prefix of one of allowed suffix, then
+      // lower_bound will return that element.
+      // If some element is prefix of 's', then lower_bound will
+      // return the next element.
+      std::set<std::string>::iterator i = allowed_prefixes.lower_bound(s);
+      if (i != allowed_prefixes.end()) {
+        if (i->find(s) == 0)
+          bad_prefixes = true;                    
+      }
+      if (i != allowed_prefixes.begin()) {
+        --i;
+        if (s.find(*i) == 0)
+          bad_prefixes = true;
+      }
+      if (bad_prefixes)
+        boost::throw_exception(boost::program_options::error("bad prefixes"));
+      allowed_prefixes.insert(s);
+    }
+  }
+
+
+  // Returns true if 's' is a registered option name.
+  bool allowed_option(const std::string& s) const
+  {
+    std::set<std::string>::const_iterator i = allowed_options.find(s);
+    if (i != allowed_options.end())
+      return true;        
+    // If s is "pa" where "p" is allowed prefix then
+    // lower_bound should find the element after "p". 
+    // This depends on 'allowed_prefixes' invariant.
+    i = allowed_prefixes.lower_bound(s);
+    if (i != allowed_prefixes.begin() && s.find(*--i) == 0)
+      return true;
+    return false;
+  }
+
+
+  // That's probably too much data for iterator, since
+  // it will be copied, but let's not bother for now.
+  std::set<std::string> allowed_options;
+  // Invariant: no element is prefix of other element.
+  std::set<std::string> allowed_prefixes;
+  std::string m_prefix;
+  bool m_allow_unregistered;
+};
+
+template<class charT>
+class basic_config_file_iterator :
+  public common_config_file_iterator
+{
+public:
+
+  basic_config_file_iterator()
+  {
+    found_eof();
+  }
+
+  /** Creates a config file parser for the specified stream. */
+  basic_config_file_iterator(std::basic_istream<charT>& is, 
+                             const std::set<std::string>& allowed_options,
+                             bool allow_unregistered = false); 
+
+private: // base overrides
+
+  bool getline(std::string&);
+
+private: // internal data
+  boost::shared_ptr<std::basic_istream<charT> > is;
+};
+
+typedef basic_config_file_iterator<char> config_file_iterator;
+typedef basic_config_file_iterator<wchar_t> wconfig_file_iterator;
+
+struct null_deleter
+{
+  void operator()(void const *) const {}
+};
+
+
+template<class charT>
+basic_config_file_iterator<charT>::
+basic_config_file_iterator(std::basic_istream<charT>& in_is, 
+                           const std::set<std::string>& in_allowed_options,
+                           bool in_allow_unregistered) :
+  common_config_file_iterator(in_allowed_options, in_allow_unregistered)
+{
+  this->is.reset(&in_is, null_deleter());                 
+  get();
+}
+
+
+// Specializing this function for wchar_t causes problems on
+// borland and vc7, as well as on metrowerks. On the first two
+// I don't know a workaround, so make use of 'to_internal' to
+// avoid specialization.
+template<class charT>
+bool
+basic_config_file_iterator<charT>::getline(std::string& s)
+{
+  if (std::getline(*is, s)) {
+    return true;
+  } else {
+    return false;
+  }
+}
+
+} /* namespace detail */
+
+/** Parse a config file. 
+
+  Read from given stream.
+*/
+template<class charT>
+boost::program_options::basic_parsed_options<charT>
+parse_config_file(std::basic_istream<charT>& is,
+                  const boost::program_options::options_description& desc,
+                  bool allow_unregistered = false)
+{    
+  std::set<std::string> allowed_options;
+
+  const std::vector<boost::shared_ptr<boost::program_options::option_description> >& options = desc.options();
+  for (unsigned i = 0; i < options.size(); ++i)
+  {
+    const boost::program_options::option_description& d= *options[i];
+
+    if (d.long_name().empty())
+      boost::throw_exception(
+                             boost::program_options::error("long name required for config file"));
+
+    allowed_options.insert(d.long_name());
+  }
+
+  // Parser return char strings
+  boost::program_options::parsed_options result(&desc);        
+  std::copy(detail::basic_config_file_iterator<charT>(
+                                                      is, allowed_options, allow_unregistered), 
+       detail::basic_config_file_iterator<charT>(), 
+       std::back_inserter(result.options));
+  // Convert char strings into desired type.
+  return boost::program_options::basic_parsed_options<charT>(result);
+}
+
+/** Parse a config file. 
+
+  Read from file with the given name. The character type is
+  passed to the file stream. 
+*/
+template<class charT>
+boost::program_options::basic_parsed_options<charT>
+parse_config_file(const char* filename,
+                  const boost::program_options::options_description& desc,
+                  bool allow_unregistered = false)
+{ 
+  // Parser return char strings
+  std::basic_ifstream< charT > strm(filename);
+  if (!strm) 
+  {
+    boost::throw_exception("Couldn't open file");
+  }
+  return parse_config_file(strm, desc, allow_unregistered);
+}
+
+} /* namespace program_options */
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_PROGRAM_OPTIONS_CONFIG_FILE_H */
+

